///////////////////////////////////////////////////////////////////////////
// Copyright © 2015 Esri Japan. All Rights Reserved.
//
// Licensed under the Apache License Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//    http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
///////////////////////////////////////////////////////////////////////////

define([
  'dojo/_base/declare',
  'jimu/BaseWidget',
  'jimu/utils',
  'dijit/form/Button',
  'esri/symbols/SimpleMarkerSymbol',
  'esri/geometry/Point',
  'esri/graphic',
  'esri/layers/GraphicsLayer',
  'esri/Color',
  'dojo/on',
  'dojo/_base/lang'
  
  ],
function(
  declare,
  BaseWidget,
  utils,

  Button,
  SimpleMarkerSymbol,
  Point,
  Graphic,
  GraphicsLayer,
  Color,
  on,
  lang
  ) {
 
  return declare([BaseWidget], {

    name: 'קפוץ לנ.צ',      //" jump to X Y"
    baseClass: 'jimu-widget-GoToXY',

    postCreate: function() {
      console.log("postCreate!");
	  var mapFrame = this;
      this.inherited(arguments);
      this.addPointsButton = new Button({
        label: "קפוץ לנקודה" //"jump to point"
      }).placeAt(this.createPointIdNode);
	  this.clearPointsButton = new Button({
        label: "נקה נקודות" //"clear markers"
      }).placeAt(this.removePointIdNode);
      this.addPointsButton.startup();
    },

    startup: function() {
	
	  
      console.log("startup!");
	  
      this.layer = new GraphicsLayer({
        dataAttributes:["id"]
      });
      if (this.layer.surfaceType === "svg") {
        on(this.layer, "graphic-draw", function (evt) {
            console.log("graphic-draw");
            var renderercategory;
            renderercategory = "GoToXY";
            evt.node.setAttribute("data-uniquevalue", renderercategory);
        });
      }
      this.map.addLayer(this.layer);

      on(this.addPointsButton, "click", lang.hitch(this, "createPoint"));
	  on(this.clearPointsButton, "click", lang.hitch(this, "clearPoint"));
      console.log("this.map: ", this.map);
    },

    createPoint: function() {
	var xx=Number(document.getElementById("ProjXBox").value);
	var yy=Number(document.getElementById("ProjYBox").value);
	if ((xx<165000)|| (xx>230000)){ //limit the area of x can be
	document.getElementById("ProjXBox").style.backgroundColor = "red";
	document.getElementById("ProjXBox").value = "נקודה מחוץ לתחום"; //"point x out of erea"
	
	}else{
	if ((yy<539000)|| (yy>594000)){
	document.getElementById("ProjYBox").style.backgroundColor = "red";
	document.getElementById("ProjYBox").value = "נקודה מחוץ לתחום"; //"point y out of erea"
	}else{
	
	document.getElementById("ProjYBox").style.backgroundColor = "white";
	document.getElementById("ProjXBox").style.backgroundColor = "white";
      console.log("createPoint!");
	  var ZoomIt = Number(10);
      var sympath = "M16 0c-5.523 0-10 4.477-10 10 0 10 10 22 10 22s10-12 10-22c0-5.523-4.477-10-10-10zM16 16.125c-3.383 0-6.125-2.742-6.125-6.125s2.742-6.125 6.125-6.125 6.125 2.742 6.125 6.125-2.742 6.125-6.125 6.125zM12.125 10c0-2.14 1.735-3.875 3.875-3.875s3.875 1.735 3.875 3.875c0 2.14-1.735 3.875-3.875 3.875s-3.875-1.735-3.875-3.875z";
      var symcolor = "#ce641d";
      var sym = new SimpleMarkerSymbol();
      sym.setPath(sympath);
      sym.setColor(new Color(symcolor));
      sym.setOutline(null);
      sym.setSize("30");
	   var randx = document.getElementById("ProjXBox").value;
      var randy = document.getElementById("ProjYBox").value;
      var attr = {"id":"rand"};
	 
      var zoomPoint = new esri.geometry.Point(Number(randx),Number(randy), this.map.spatialReference);
           this.map.centerAndZoom(zoomPoint,10);       

     
      var pt = new Point(randx, randy, this.map.spatialReference);
	  
	 
	  pntd=new Graphic(pt, sym, attr);
      this.layer.add(pntd);
	 }
	 }
	  
    },
	clearPoint: function() {
this.layer.clear();
//this.map.removeLayer(this.layer)
	} 
  });

});
